module CacheSim.Model exposing (..)
import CacheSim.Raw exposing (..)
import CacheSim.Hierarchy exposing (..)
import CacheSim.AccessView exposing (..)

type alias Model =
    { rawHierarchy : RawCacheModelHierarchy
    , hierarchy : Maybe CacheHierarchy
    , accessView : Maybe (List AccessView)
    , accessInput : String
    }
type alias Flags = ()
type Msg
    = ChangeRawModel Int (RawCacheModel -> RawCacheModel)
    | CreateRawModel
    | DeleteRawModel Int
    | UseHierarchy (Maybe CacheModelHierarchy)
    | Access (List Int)
    | ChangeAccessInput String
    | AccessViewCancel
    | AccessViewForward
    | AccessViewBack
